import socket
import pickle

HOST = 'localhost'
PORT = 1234
SERVER_ADDRESS = HOST, PORT

class Mensaje():
	def __init__(self,funcio,parametres):
		self.funcio = funcio
		if len(parametres)>0:
			self.parametres = parametres
		else:
			self.parametres=[] 
class Proxy(object):
	def __init__(self,host,port,name):
		self.host = host
		self.name = name
		self.port = port

	def __getattr__(self, name):
		print "Creating a dynamic method named: " + name
		setattr(self, name, self.genericRemoteCall)
		self.functionName = name
		return getattr(self, name)

	def genericRemoteCall(self,*args):
		s = socket.socket()
		#invoco el metodo connect del socket pasando como parametro la tupla IP , puerto
		s.connect((self.host,self.port))
		m = pickle.dumps(Mensaje(self.functionName,args))#Serializamos los parametros				
		s.send(m)
  		recibido = s.recv(1024)
		print pickle.loads(recibido) #Mostramos por pantalla el resultado deserializado
		s.close()
		return pickle.loads(recibido)
		
	def __getstate__(self):
		odict = self.__dict__
		return odict

	def __setstate__(self,dict):
		self.__dict__ = dict

